from collections import defaultdict
from functools import wraps

def infinitedict():
    d = lambda: defaultdict(d)
    return defaultdict(d)

# NOTE - Is this useful? I have no idea, but here it is!
def decorator(wrapper):
    def wrapper_decorator(func):
        @wraps(func)
        def wrapper_wrapper(*args, **kwargs):
            return wrapper(*args, **kwargs)
        return wrapper_wrapper
    return wrapper_decorator

def debugger(func):
    @wraps(func)
    def wrapper_debug(*args, **kwargs):
        args_repr = [repr(arg) for arg in args]
        kwargs_repr = [f"{key}={value!r}" for key, value in kwargs.items()]
        signature = ", ".join(args_repr + kwargs_repr)
        print(f"[DEBUGGER]: Calling {func.__name__}({signature})")
        result = func(*args, **kwargs)
        print(f"[DEBUGGER]: {func.__name__!r} returned {value!r}")
        return value
    return wrapper_debug

def coroutine(func):
    @wraps(func)
    def wrapper_coroutine(*args, **kwargs):
        coro = func(*args, **kwargs)
        coro.send(None)
        return coro
    return wrapper_decorator
